/*
* Copyright 2020 Kumori systems S.L.
*
* Licensed under the EUPL, Version 1.2 or – as soon they
* will be approved by the European Commission - subsequent
* versions of the EUPL (the "Licence");
* You may not use this work except in compliance with the
* Licence.
* You may obtain a copy of the Licence at:
*
* https://joinup.ec.europa.eu/software/page/eupl
*
* Unless required by applicable law or agreed to in
* writing, software distributed under the Licence is
* distributed on an "AS IS" basis,
* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either
* express or implied.
* See the Licence for the specific language governing
* permissions and limitations under the Licence.
 */
// Code generated by lister-gen. DO NOT EDIT.

package v1beta1

import (
	v1beta1 "gitlab.com/kumori-systems/community/libraries/clusterapi-client-go/pkg/apis_bootstrap/bootstrap/v1beta1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// KubeadmConfigTemplateLister helps list KubeadmConfigTemplates.
// All objects returned here must be treated as read-only.
type KubeadmConfigTemplateLister interface {
	// List lists all KubeadmConfigTemplates in the indexer.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.KubeadmConfigTemplate, err error)
	// KubeadmConfigTemplates returns an object that can list and get KubeadmConfigTemplates.
	KubeadmConfigTemplates(namespace string) KubeadmConfigTemplateNamespaceLister
	KubeadmConfigTemplateListerExpansion
}

// kubeadmConfigTemplateLister implements the KubeadmConfigTemplateLister interface.
type kubeadmConfigTemplateLister struct {
	indexer cache.Indexer
}

// NewKubeadmConfigTemplateLister returns a new KubeadmConfigTemplateLister.
func NewKubeadmConfigTemplateLister(indexer cache.Indexer) KubeadmConfigTemplateLister {
	return &kubeadmConfigTemplateLister{indexer: indexer}
}

// List lists all KubeadmConfigTemplates in the indexer.
func (s *kubeadmConfigTemplateLister) List(selector labels.Selector) (ret []*v1beta1.KubeadmConfigTemplate, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.KubeadmConfigTemplate))
	})
	return ret, err
}

// KubeadmConfigTemplates returns an object that can list and get KubeadmConfigTemplates.
func (s *kubeadmConfigTemplateLister) KubeadmConfigTemplates(namespace string) KubeadmConfigTemplateNamespaceLister {
	return kubeadmConfigTemplateNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// KubeadmConfigTemplateNamespaceLister helps list and get KubeadmConfigTemplates.
// All objects returned here must be treated as read-only.
type KubeadmConfigTemplateNamespaceLister interface {
	// List lists all KubeadmConfigTemplates in the indexer for a given namespace.
	// Objects returned here must be treated as read-only.
	List(selector labels.Selector) (ret []*v1beta1.KubeadmConfigTemplate, err error)
	// Get retrieves the KubeadmConfigTemplate from the indexer for a given namespace and name.
	// Objects returned here must be treated as read-only.
	Get(name string) (*v1beta1.KubeadmConfigTemplate, error)
	KubeadmConfigTemplateNamespaceListerExpansion
}

// kubeadmConfigTemplateNamespaceLister implements the KubeadmConfigTemplateNamespaceLister
// interface.
type kubeadmConfigTemplateNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all KubeadmConfigTemplates in the indexer for a given namespace.
func (s kubeadmConfigTemplateNamespaceLister) List(selector labels.Selector) (ret []*v1beta1.KubeadmConfigTemplate, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1beta1.KubeadmConfigTemplate))
	})
	return ret, err
}

// Get retrieves the KubeadmConfigTemplate from the indexer for a given namespace and name.
func (s kubeadmConfigTemplateNamespaceLister) Get(name string) (*v1beta1.KubeadmConfigTemplate, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1beta1.Resource("kubeadmconfigtemplate"), name)
	}
	return obj.(*v1beta1.KubeadmConfigTemplate), nil
}
